 % Generisanje ulaznog signala i cuvanje u .pcm formatu

magnitude = 2^15/3;       % amplituda sinusoide
sampling_freq = 5000;     % ucestanost odabiranja
sine_1_freq = 800;        % ucestanost prve sinusoide
sine_2_freq = 1200;       % ucestanost druge sinusoide
sine_3_freq = 2450;       % ucestanost trece sinusoide

% Vremenski opseg za prikazivanje na grafiku
time = 0 : 1/sampling_freq : 1-1/sampling_freq;

% Generisanje sinusoida
input_sine_1 = magnitude * sin(2*pi*sine_1_freq*time);
input_sine_2 = magnitude * sin(2*pi*sine_2_freq*time);
input_sine_3 = magnitude * sin(2*pi*sine_3_freq*time);

% Generisanje ulaznog signala koji predstavlja zbir tri sinusoide 
input_sine = input_sine_1 + input_sine_2 + input_sine_3;

% Frekvencijski opseg za prikazivanje na grafiku
freq = sampling_freq * (-length(input_sine)/2 : length(input_sine)/2-1) / length(input_sine);

% Izrazunavanje amplitudske i fazne karakteristike
magnitude_response = fftshift(abs(fft(input_sine)));     
phase_resonse = unwrap(angle(fft(input_sine)));  

% Vremenski dijagram ulaznog signala
figure('name', 'Time diagram');
plot(time, input_sine);
ylabel('Input signal');
xlabel('Time [s]');

% Prikazivanje amplitudske karakteristike
figure('name', 'Magnitude response');
plot(freq, magnitude_response);
ylabel('Magnitude');
xlabel('Frequency [Hz]');

% Prikazivanje fazne karakteristike
figure('name', 'Phase response');
plot(freq, phase_resonse);
ylabel('Phase');
xlabel('Frequency [Hz]');

% Cuvanje ulaznog signala u .pcm formatu
fid = fopen('input.pcm', 'w');
fwrite(fid, input_sine, 'int16');          




